<!DOCTYPE html>
<head>
    <meta charset="utf-8"/>
    <title>twitter explorer</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/awesomplete/1.1.5/awesomplete.min.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/awesomplete/1.1.5/awesomplete.min.js"></script>
    <script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script>
    <script src="https://d3js.org/d3.v4.js"></script>
    <script src="https://unpkg.com/force-graph"></script>
    <link href="https://fonts.googleapis.com/css2?family=Inter:wght@400;700&display=swap" rel="stylesheet">     
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/file-saver@2.0.2/dist/FileSaver.min.js"></script>    
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    <script> 
    $(document).ready(function(){
      $("#panel00").click(function(){
        $("#content00").slideToggle(300);
              });
    });
    $(document).ready(function(){
      $("#panel01").click(function(){
        $("#content01").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel02").click(function(){
        $("#content02").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel03").click(function(){
        $("#content03").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel04").click(function(){
        $("#content04").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel04A").click(function(){
        $("#content04A").slideToggle(300);
      });
    });    
    $(document).ready(function(){
      $("#panel05").click(function(){
        $("#content05").slideToggle(300);
      });
    });
    $(document).ready(function(){
      $("#panel06").click(function(){
        $("#content06").slideToggle(300);
      });
    });
    $( function() {
        $( "#totalborder" ).draggable();
        } );
    </script>
<style>
.switch {
    position: relative;
    width: 60px;
    }
/* Hide default HTML checkbox */
    .onoffswitch {
        position: relative;         
        margin: 10px;
        /*margin-left:270px;*/
        width: 40px;
        -webkit-user-select:none; -moz-user-select:none; -ms-user-select: none;
    }
    .onoffswitch-checkbox {
        display: none;
    }
    .onoffswitch-label {
        display: block; overflow: hidden; cursor: pointer;
        height: 15px; padding: 0; line-height: 15px;
        border: 2px solid #999999; border-radius: 15px;
        background-color: #EEEEEE;
        transition: background-color 0.3s ease-in;
    }
    .onoffswitch-label:before {
        content: "";
        display: block; width: 15px; margin: 0px;
        background: #FFFFFF;
        position: absolute; top: 0; bottom: 0;
        right: 23px;
        border: 2px solid #999999; border-radius: 15px;
        transition: all 0.3s ease-in 0s; 
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label {
        background-color: #fff;
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label, .onoffswitch-checkbox:checked + .onoffswitch-label:before {
       border-color: #999999;
    }
    .onoffswitch-checkbox:checked + .onoffswitch-label:before {
        right: 0px; 
    }
    html.transition,
    html.transition *,
    html.transition *:before,
    html.transition *:after {
      transition: ease-in-out 200ms !important;
      transition-delay: 0 !important;
    }
      html {
          background: var(--backg);
                    --backg: #fff;
                    --color_text: #000;
                    --color_title_text: #fff;
                    --color_title_backg: #000;
                    --backg_buttons: rgba(0,0,0,0.15);}
      html[data-theme='darktheme'] {
          background: var(--backg);
          --backg: #000;
          --color_text: #fff;
          --color_title_text: #000;
          --color_title_backg: #fff;
          --backg_buttons: rgba(255,255,255,0.25)
            }
      body {margin: 0; 
            font-family: "Inter",-apple-system,system-ui,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif;
            font-size: 12pt;
            background-color: var(--backg);
            color: var(--color_text)}

        #totalborder {
        border: 1px;
        margin: 25px;
        width: 325px;
        border-style: solid;
        padding-left: 0px;
        position: relative;
        float: left;
        z-index: 10;
        background-color: var(--backg)
        }

        #totalborder:hover {
          cursor: move
        }
        
        #panel00{
          text-decoration: underline;
          text-transform: uppercase;
        }

        .borders {
          border: solid 1px;
          margin: 10px;
          width: 300px;
        }
        .borders_small {
          border: solid 1px;
          margin: 0px;
          width: 270px;
          margin-top: 10px
        }

        #title {
        padding: 10px;
        width: 300px;
        color: var(--color_title_text);
        font-size: 20pt;
        font-weight: bold;
        }

        #titleborder {
        background-color: var(--color_title_backg)
        }

        .content {
          display: none;
          padding: 10px;
        }

        .subtitle {
          padding: 10px;
        }
        .subsubtitle {
          padding: 5px;
          font-size: 11pt;
        }

        .subtitle:hover{
          background-color: var(--backg_buttons);
          cursor: pointer;
        }
        .subsubtitle:hover{
          background-color: var(--backg_buttons);
          cursor: pointer;
        }

        #footer{
          font-size: 8pt;
          padding-left: 10px;
          padding-bottom: 5px;
          color:grey;
        }

        a{
          color:var(--text-color);
        }
        #infodiv{
            padding-left: 20px;
            position: relative;
            float: left;
            z-index: 10;
        }
        iframe.infodiv{
                padding-left:0px;

        }
        @media(max-width:1000px){
            #infodiv{
                padding-left:0px;
            }
            #stripecontainer{
              padding-left:0;
            }
        }
        /* ---------------------------- */  
        /* ---------- Selector ---------- */
        #mainselection select {
           border: 1;
           border-width: 1px;
           /*border-color: black;*/
           border-radius: 4px;
           background: transparent;
           font-size: 11pt;
           color: var(--text_color);
           padding: 2px 5px;
           width: 270px;
           -webkit-appearance: none;
        }
        #mainselection {
           /*overflow:hidden;*/
           width:240px;
           border: 1;
           /*background: #58B14C no-repeat scroll 150px center;*/
        }
        /* ---------------------------- */  
        /* ---------- Button ---------- */
        .button1 {
            background-color:transparent;
            border-radius:4px;
            margin-top: 10px;
            border:1px solid;
            display:inline-block;
            cursor:pointer;
            color:var(--color_text);
            width: 119px;
            font-size:10pt;
            padding:5px 5px;
            /*padding:6px 36px;*/
            text-decoration:none;
            margin-right: 5px
          }
          .button1:hover {
            background-color: var(--backg_buttons);
          }
          .button1:active {
            position:relative;
            top:1px;
          }
        .button2 {
            background-color:transparent;
            border-radius:4px;
            margin-top: 20px;
            border:1px solid;
            display:inline-block;
            cursor:pointer;
            color:var(--color_text);
            width: 140px;
            font-size:10pt;
            padding:5px 5px;
            /*padding:6px 36px;*/
            text-decoration:none;
            margin-right: 5px
          }
          .button2:hover {
            background-color: var(--backg_buttons);
          }
          .button2:active {
            position:relative;
            top:1px;
          }                    
        /* ---------------------------- */  
        /* ---------- Checkbox ---------- */
        .checkbox {
            display: inline-flex;
            cursor: pointer;
            position: relative;
        }
        .checkbox > span {
            padding: 0.3rem 0.5rem;
            font-size: 12pt
        }
        .checkbox > input {
            height: 25px;
            width: 25px;
            -webkit-appearance: none;
            -moz-appearance: none;
            -o-appearance: none;
            appearance: none;
            border: 1px solid;
            border-radius: 4px;
            outline: none;
            transition-duration: 0.3s;
            background-color: transparent;
            cursor: pointer;
            margin-left: 1px
          }
        .checkbox > input:checked {
            border: 1px solid;
        }
        .checkbox > input:checked + span::before {
            content: '\2713';
            display: block;
            text-align: center;
            color: var(--color_text);
            position: absolute;
            left: 0.3rem;
            top: 0.2rem;
            font-size: 14pt

        }
        .checkbox > input:active {
            border: 2px solid #34495E;
        }
        .description{
            font-size:9pt;
            margin-top: 0px
        }
        .element{
          margin-bottom: 10px
        }
        #twittertimeline{
          margin-top: 0px
        }
        /* ---------------------------- */  
        /* ---------- Search Box ---------- */
        input[type=search] {
            border-radius: 4px;
            font-size: 12pt;
            width: 272px;
            background-color: transparent;
            color: var(--color_text);
        }
        /* ---------------------------- */
        ul{
            padding-left:15px;
            list-style-type:circle; 
            font-size: 11pt; 
            margin-top: 0px;
            margin-bottom: 0px;
        }
        #slido{width: 270px;}
        #time_slider{width: 270px;}
        #slido_links{width: 270px;}        
        #scale{margin-top: 20px}
        #user_retweets{
          overflow-y: scroll;
          scrollbar-width: none; /* Firefox */
          -ms-overflow-style: none;  /* Internet Explorer 10+ */          
          height: 300px;
        }
        #user_retweets::-webkit-scrollbar { /* WebKit */
        width: 0;
        height: 0;
        }
        #user_originaltweets{
          overflow-y: scroll;
          scrollbar-width: none; /* Firefox */
          -ms-overflow-style: none;  /* Internet Explorer 10+ */          
          height: 300px;
        }
        #user_originaltweets::-webkit-scrollbar { /* WebKit */
        width: 0;
        height: 0;
        }        
        .loader {
            border: 12px solid #f3f3f3;
            border-radius: 50%;
            border-top: 12px solid #444444;
            width: 35px;
            height: 35px;
            animation: spin 1s linear infinite;
            display: none;
        }        
        @keyframes spin {
            100% {
                transform: rotate(360deg);
            }
        }
        .svgbutton00 {
          padding-top: 6px;
          padding-bottom: 0px;
          }
          .svgbutton00:hover{
            cursor: pointer;
          }
        .svgbutton00 svg {
          width: 24px;
          height: 24px;
          stroke: var(--color_text);
          stroke-width: 4;
          stroke-linecap: square;
          stroke-linejoin: miter;
          fill: var(--color_text);
        }
        .svgbutton00 svg:hover{
            stroke: magenta;
        }             
        .svgbutton01 {
          /*border-radius: 4px;*/
          padding-top: 3px;          
          /*float: right;*/
          }
          .svgbutton01:hover{
            cursor: pointer;
          }
        .svgbutton01 svg {
          width: 30px;
          height: 30px;
          stroke: var(--color_text);
          stroke-width: 4;
          stroke-linecap: square;
          stroke-linejoin: miter;
          fill: none;
        }
        .svgbutton01 svg:hover{
            stroke: magenta;
        }          
</style>
</head>
<body>
<div id="totalborder">
<div style="display:flex">
<div style="padding-left: 10px;" class="svgbutton00">
<svg onclick='toggle_darkmode()' height='100px' width='100px'  fill="#000000" xmlns="http://www.w3.org/2000/svg" data-name="Layer 1" viewBox="0 0 100 100" x="0px" y="0px"><title>Toggle dark mode</title><path d="M50,2.5A47.5,47.5,0,1,0,97.5,50,47.5,47.5,0,0,0,50,2.5Zm0,90.56A43.06,43.06,0,1,1,93.06,50,43.11,43.11,0,0,1,50,93.06ZM14.93,49.56A35.51,35.51,0,0,0,50.44,85.07V14A35.51,35.51,0,0,0,14.93,49.56Z"></path></svg>
</div>
<div style="padding-left: 250px;" class="svgbutton01" title='Make a screenshot of the current graph view'>
<a id='camera'></a>    
<svg onclick='make_screenshot()' height='100px' width='100px'  fill="#000000" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 100 100" enable-background="new 0 0 100 100" xml:space="preserve"><path d="M92.5,27.5H35V20c0-1.4-1.1-2.5-2.5-2.5h-15c-1.4,0-2.5,1.1-2.5,2.5v7.5H7.5C6.1,27.5,5,28.6,5,30v50c0,1.4,1.1,2.5,2.5,2.5  h85c1.4,0,2.5-1.1,2.5-2.5V30C95,28.6,93.9,27.5,92.5,27.5z M20,22.5h10v5H20V22.5z M90,77.5H10v-45h80V77.5z"></path><path d="M50,72.5c9.6,0,17.5-7.9,17.5-17.5S59.6,37.5,50,37.5S32.5,45.4,32.5,55S40.4,72.5,50,72.5z M50,42.5  c6.9,0,12.5,5.6,12.5,12.5S56.9,67.5,50,67.5S37.5,61.9,37.5,55S43.1,42.5,50,42.5z"></path></svg>
</div>
</div>
<div class="borders" id="titleborder" style="margin-top:0">
<div id="title">twitter explorer <span id="version_number" style="font-size:8pt"></span></div>
</div>
<div class="borders">
<div class= "subtitle" id="panel00"></div>
<div class = "content" id="content00" style="padding-top:0px">
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel01">VISUALIZATION OPTIONS</div>
<div class = "content" id="content01">
    <div id="mainselection" class="element">
        <div class="description">Auto-color nodes by</div>
            <select id = "nodecolor">
                <option value = "none" style="font-weight: bold"></option>
            </select>
        <br> <br>
        <div class="description">Node size (variable scale)</div>
            <select id = "nodesize">
                <option value = "none">None</option>
                <option value = "in_degree" id="indegreeoption">In-Degree (number of times the user got retweeted)</option>
                <option value = "out_degree" id="outdegreeoption">Out-Degree (number of times the user retweeted someone)</option>
                <option value = "followers">Number of followers</option>
                <option value = "friends">Number of followed accounts</option>
            </select>
        </div>
        <div class="description" id="scale">Size scale</div>
        <div class="slidecontainer">
          <input type="range" min="0.2" max="20" value="2" id="slido">
        </div>
        <a href="javascript:void(0);" onclick="toggle_linkvisibility()" class="button2">Toggle link visibility</a>  
<div class="description" style="padding-top:20px" id="time_scale">Filter edges by day (experimental feature)</div>
    <div class="slidecontainer">
        <input type="range" min="0" max="25" value="0" id="time_slider">
    </div>
    <div id="current_time_filter" style="font-size:9pt"></div>                      
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel02">NETWORK MEASURES</div>
<div class = "content" id="content02">
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel03">ACCOUNT INFORMATION</div>
<div class = "content" id="content03">
    <div class="description"> Search user</div>
    <input id="searchuser" type="search"/>
        <br>
        <a href="javascript:void(0);" onclick="zoomonuser()" class="button1">Zoom on node</a>
        <a href="javascript:void(0);" onclick="drawortweets()" class="button1" id="fetch_originaltweet">Fetch tweets</a><br>        
        <a href="javascript:void(0);" onclick="drawretweets()" class="button1" id="fetch_interaction"></a>
        <a href="javascript:void(0);" onclick="drawtimeline()" class="button1">Fetch timeline</a> 
    <br><br>
    <div id="userinfostring"></div>
    <div class="borders_small" id="originaltweetsborders">
        <div class= "subsubtitle" id="panel04A">ORIGINAL TWEETS IN DATASET</div>
        <div class = "content" id="content04A">
            <div id="user_originaltweets">
                <div class="loader"></div>
                <a id="useroriginaltweets" class="useroriginaltweets"></a>
            </div>
        </div>
    </div>  
    <div class="borders_small">
        <div class= "subsubtitle" id="panel04"></div>
        <div class = "content" id="content04">
            <div id="user_retweets">
                <a id="userretweets" class="userretweets"></a>
            </div>
        </div>
    </div>   
    <div class="borders_small">
        <div class= "subsubtitle" id="panel05">TWITTER TIMELINE</div>
        <div class = "content" id="content05">
            <div id="twittertimeline">
                <a id="twitter_timeline" class="twitter-timeline"></a>
            </div>
        </div>
    </div>
</div>
</div>
<div class="borders">
<div class= "subtitle" id="panel06">EXPORT OPTIONS</div>
<div class = "content" id="content06">
<a href="javascript:void(0);" onclick="export_nodes_as_csv()" class="button1" style="margin-top:0">Export nodes and metadata as CSV</a>   
<a href="javascript:void(0);" onclick="d3graph_to_gml()" class="button1" style="margin-top:0">Export graph as GML (for Gephi)</a>     
</div>
</div>
<!-- <div id="footer">Created with the <a href="https://twitterexplorer.org">twitter explorer</a></div></div> -->
</div>

<div id="graph" style="width:100%;height: 100%;position: absolute;"></div>

    <script type="text/javascript">
        var data = {'nodes': [{'id': 0, 'twitter_id': '18504485', 'screen_name': 'athanorster', 'followers': 2815, 'friends': 964, 'interactions': ['813815672899858434', '1184434975011151872', '1168784582235365376', '1186184877688918017', '1297185282274594816', '1252506577090809862', '1472253420232978441', '1369769003137241092', '1460720907509538816', '1426807827155324928', '1386353447134535682', '1543240645577510912', '1542190342115557378', '1519014048679043072', '1502618561625436160', '1564284349343752195', '1587359369339015168', '1585543729984700418', '1583409071801016320', '1573968700637646848', '1564274977708318722', '1563100691371294720', '1539126956079333376', '1621478845869166592'], 'otweets': ['628948513964093440', '635812276285644800', '625711864094302208', '731111696962605056', '728258612179558400', '687257130890440704', '806122066219069442', '804660616719896576', '766705727574511616', '766569169873670144', '761582016164880385', '758179826536685569', '755421899090374656', '741602684864626691', '724615481198534657', '790557691861209089', '782961406211751938', '781904140972720128', '776823890521821185', '774218046487597056', '769589255081496576', '753174102542848000', '748545417109962752', '743370363631984640', '737906102025785345', '933606273576251392', '919281236593528832', '893777870757253120', '899963499169947649', '874886851030593537', '858707838692098049', '856962333725347840', '838037653836554240', '836634506580770816', '836109214737035264', '833720478191775745', '1014180872751407104', '981579904235069440', '1062990805881606144', '1002529378679644160', '974626492524187648', '974606576911896577', '1017478900149030913', '1005346602419195905', '981084673223913472', '961188212269047808', '961187795703250944', '1207015262060523523', '1204301782635163649', '1191391916291739649', '1178727692402937856', '1155888668156018690', '1148202820023345152', '1148192874804195330', '1210641450133790720', '1210249311784751104', '1209173113872756736', '1208744173907648512', '1208440953045954562', '1208093396121931789', '1207337882022752256', '1206649876433580034', '1206233732736258055', '1205944311751303168', '1205590445557981190', '1205388763901419520', '1204831087937171458', '1204766744159694849', '1204470222675206144', '1204299752894017536', '1204107455048929280', '1203756792955768833', '1203656078204030977', '1203257657416716290', '1202860846373847040', '1202860587946041344', '1202636943613403138', '1202137318922104832', '1201920667022696448', '1201825919792504832', '1201588416594489344', '1201411234777718785', '1201218304037326848', '1201159132612583424', '1200698833627422720', '1200113139012001797', '1199957285415669760', '1199741038904139781', '1199591628832477184', '1199387510897545216', '1199234211829440513', '1199041184951414784', '1198865058744471552', '1198659154732355584', '1198520017672904705', '1198303023795191808', '1198156029768425472', '1197935844868395014', '1197876422599172096', '1197783648814190592', '1197609694552088576', '1179319519950581760', '1178953433996496897', '1171412058413383680', '1171089869617209344', '1160882175954358272', '1160851579102277632', '1153915719467319296', '1148216590002982912', '1144156848637009920', '1119303026286657536', '1111022070740193280', '1109037746306383874', '1301562540913295360', '1242517176596271107', '1225323817859502080', '1340025775274209281', '1333113165241065478', '1332036064316325888', '1331316545901965312', '1330253000229707788', '1329862081261297668', '1329485669123624962', '1329115580473946119', '1328756469588774913', '1328427846998618113', '1328056179688435715', '1326604601093722120', '1326224942602596354', '1325852098920148992', '1325461167427477505', '1325120690354315275', '1324758711311736833', '1324395577182953473', '1324039246072684549', '1323692335742521344', '1322921227967746060', '1322560908334424066', '1322219791332102144', '1322198073087533056', '1321847987346296832', '1321511025397682184', '1318631527887101953', '1318229103154266114', '1316436008083296262', '1314518869197946885', '1311348359719006208', '1306309754306932742', '1305457311859777536', '1300165542884577282', '1298951198641475588', '1297625717472100354', '1296764830859362304', '1291411508807766022', '1288546839206256640', '1288030510330126336', '1287838225566965761', '1276897716082278401', '1259034941150638081', '1258750626718236672', '1258668667346325504', '1258344656577970177', '1258321334943260678', '1258298798046154753', '1258297559006748672', '1258078688253489153', '1257977262550417408', '1257935563128258560', '1257719807350378496', '1257630880706834432', '1257567025184018432', '1257350430125850635', '1257245550438735873', '1257183074921656323', '1257036692978126849', '1256994327093542912', '1256886227174817793', '1256842637589516288', '1256631043874009090', '1256527412780810241', '1256481620665786369', '1256193739762143232', '1256129464368496640', '1255906874706272256', '1255814384720502784', '1255740367984566273', '1255542783366086660', '1255440429669126151', '1255377696680562690', '1255182920932896769', '1255094099469893633', '1255077927227731968', '1255009030126424065', '1254829452523122701', '1254718757861306369', '1254672926323900421', '1254456396235575298', '1254373244158775296', '1254316080719413249', '1254088356511780866', '1253990791904624640', '1253963727872933890', '1253746935766360064', '1253633614937456641', '1253576718415269890', '1253376078061735943', '1253274746038468609', '1253227996741283847', '1253009657372737543', '1252898628928245760', '1252857099853328390', '1252641479018897415', '1252549757609873408', '1252504734231134208', '1252188024802246658', '1252140721987096576', '1251918044781326336', '1251809736674156546', '1251761844743802880', '1251562349519142914', '1251455831780077570', '1251423434023882758', '1251192962912051206', '1251093421529366528', '1251040335658201089', '1250835587604647936', '1250732214263984128', '1250684986811977730', '1250478398981443589', '1250366763176546305', '1250340084676562944', '1250301724524347394', '1250116206922784771', '1250002798080659456', '1249957201730588672', '1249744322502803457', '1249638713300332545', '1249600018887192576', '1249392268219424769', '1249286227813072902', '1249209438277419010', '1249023278884229125', '1248917341179699200', '1248873204275445761', '1248675709318561793', '1248554993776459776', '1248492064079147008', '1248292209037905922', '1248192412108886017', '1248132444173357057', '1247933152716378112', '1247825280397381634', '1247775034862497792', '1247570130478997506', '1247463223848247297', '1247413470032789504', '1247210622351216644', '1247104071510773768', '1247046775598440450', '1246845260631814144', '1246741171826810880', '1246686748400390144', '1246494327922188288', '1246391977425481728', '1246333227058462720', '1246128744848384002', '1246021489222090758', '1245963405162397697', '1245761170105081856', '1245656656303685632', '1245606412840919045', '1245401375703552001', '1245348276171354112', '1245254641803239424', '1245034313395179526', '1244928958694596608', '1244878593412530177', '1244671188862930951', '1244578456203116546', '1244532665899982851', '1244528689771094017', '1244312145698922498', '1244213658349076480', '1244165073033191425', '1243961067979657216', '1243861746395361280', '1243795118345326592', '1243634864097804288', '1243597399764975617', '1243492843294986241', '1243443136539627520', '1243245600369491969', '1243138976371871745', '1243072067999801344', '1242884914997088256', '1242765464356487169', '1242703174911373312', '1242508678600839171', '1242348578959503360', '1242156208603172866', '1242045163540819971', '1242006387594575875', '1241983777162788865', '1241813249500286976', '1241632743198461952', '1241424746950152192', '1241338388038529025', '1241268842632011776', '1241081763851579392', '1240959934063423490', '1240884992550502401', '1240704562568130561', '1240599968903299075', '1240544442735570945', '1240333904206336003', '1240228420170256384', '1240169068478504960', '1239875851585552387', '1239812913356996609', '1239635457329283072', '1239508330198052864', '1239455523059175426', '1239257230953918464', '1239211601221337088', '1239142429036593152', '1239069111864438785', '1238885842397118468', '1238839527545999360', '1238778332034015234', '1238737574904152064', '1238533694832414721', '1238429373075775488', '1238363686890332160', '1238205093805203457', '1237106787750424582', '1236714608339058691', '1236379783283556352', '1236025581592080390', '1235101485752442880', '1234759130948210691', '1234580759794634752', '1233140390624137217', '1232757631649013761', '1232403219688689664', '1231284214693273602', '1230856556834627585', '1230764612976431106', '1230570877949038592', '1230209185356353539', '1230157006931202048', '1228695082091646977', '1228033089047322625', '1227288820464250880', '1226969010891370497', '1226819689214595072', '1226608472051142665', '1226209708765253632', '1225682762939584515', '1225680300073598976', '1225149998859530242', '1224962911422074880', '1224225216047603712', '1223341524307599360', '1223282051429912578', '1222935145998581760', '1221129751760457728', '1221007069387612160', '1217530093020598272', '1216419597110390790', '1215702406589308928', '1215641840994717701', '1215372181733085190', '1214659681739821057', '1212337714777010177', '1234016918702559234', '1476584048860540930', '1475143048866799621', '1474087724898566149', '1473704754983358466', '1473318575230304268', '1472958587311951872', '1471135813538918404', '1470050956926754816', '1469325744945913857', '1467537225646804999', '1466791253320912905', '1465371237157384202', '1464624736844095490', '1464299874267054082', '1463889866790424579', '1463208130423271425', '1460631624442392579', '1458478220869779460', '1453742565820354567', '1453017665065390081', '1448720642061344769', '1446937132136816641', '1445781751167524869', '1445431144179191811', '1445051344717484046', '1444692990946160646', '1443600479607533577', '1443236348379508742', '1439264826333794312', '1438523210060992512', '1438159939491540992', '1409218731688009741', '1403401436419985414', '1401560942337482752', '1432053150199033861', '1417505062910406657', '1453689553760444418', '1379144369052266501', '1460664608943915023', '1454177085900083200', '1451466872663298084', '1445051361436000258', '1442876862758227974', '1442536264394166272', '1440283322018500612', '1438170326429544449', '1437080225435815936', '1436336575739224071', '1435627966692724738', '1434923842640691201', '1433492161731907590', '1433097219993972741', '1430924674326728713', '1430922853705306117', '1428014912056532994', '1426480411098681346', '1425500657260404739', '1423171764629250048', '1422940818864758792', '1419351218439196678', '1417867506459496454', '1412130821834674183', '1410678955103883276', '1407776512267456513', '1402317904914309124', '1401919784523112449', '1399736168493748228', '1386351809044914176', '1377542131179515906', '1373559049774637056', '1373191750039261187', '1373189989912174595', '1366047009791242244', '1366007828129972225', '1360921164533620736', '1397564429005373440', '1562118754716246017', '1561642789284331520', '1555084824666378240', '1554470869002604544', '1554157898963554304', '1553756457086205953', '1553412768367247360', '1553046431577014274', '1552318644092280835', '1550141795941711872', '1549799504584609793', '1549393149621043200', '1547980705388302337', '1547173707109498885', '1546157193006927872', '1545427102467608578', '1545074773293768705', '1543981359152205824', '1543943536906756104', '1543241637379325952', '1537459059590299656', '1537456378226302977', '1536419498718265345', '1535329135656337408', '1534576976417243143', '1531895980160860161', '1531660584248348673', '1531592225993461763', '1529353483131953152', '1527313104140644352', '1526215057381761024', '1525134464476663813', '1524771157165150210', '1524409838201094147', '1523918116924887040', '1523361208857862144', '1522982356759597058', '1522607518756790279', '1522599694207266817', '1521522020458061825', '1521490566357389320', '1517174564031188992', '1516092343258075151', '1514280827047264262', '1513900781891637254', '1513131508604755970', '1512133261115465735', '1512087371591811074', '1511362943119671302', '1510286484556951555', '1508473940057989124', '1507738145240109069', '1506294383745843210', '1506006088533037058', '1505617459507871748', '1505090049251098624', '1504500742555676694', '1503714266536366080', '1503629868910710789', '1503031790495322112', '1502244686391611393', '1501954274313613313', '1499416053113364490', '1498683278710259717', '1496504574114517000', '1496155026410065928', '1491808299859197955', '1487089185299308544', '1483860101140291588', '1482072614327754759', '1477297421306712066', '1554864675447361541', '1601603003311878145', '1598023413112754177', '1595781725145137153', '1574802055885119489', '1572242645623386112', '1585967368374976514', '1576561846349627393', '1563787725941129216', '1562000599616524288', '1560927412011032577', '1560880250984308737', '1558870010545770502', '1554476333429825547', '1554108901372698629', '1525093650316808192', '1606200628098654208', '1605581214705860608', '1601506699466387456', '1600851337305989120', '1600168752670048262', '1599497121136185344', '1599497116082405376', '1598429448667275265', '1597967663766343683', '1597530047958888448', '1594768998545166342', '1590442874977816576', '1588963828930600960', '1588963799356559360', '1588963789642219520', '1588228103804968961', '1588078403713916929', '1587448162955960320', '1587359377635348482', '1585606970530217984', '1584442558481956864', '1583525662689619968', '1583386905374183425', '1579735216280989696', '1576489577673805824', '1575745919407968259', '1575494235196772357', '1575131540794793987', '1574723247890960384', '1574308244469817344', '1572491714706669568', '1570763162273861632', '1570762468145889280', '1570760094232772610', '1569967816824029184', '1567760656488665088', '1567456622150127616', '1566769047886331905', '1566425654039568391', '1566335960538816513', '1565672534221197315', '1564312340350255105', '1563101014420402177', '1562871383461281793', '1562871346001956871', '1562472899914924033', '1560186145639636993', '1559196692863410177', '1559196676912472066', '1556326523027742720', '1556326494577856520', '1556326487690825728', '1556326483110629377', '1556231471580446722', '1549442704676999169', '1549442686779764736', '1548368621159690241', '1545770422104358912', '1545770404870078464', '1543516427885260801', '1542189764836818944', '1539195595272888321', '1538533100082413571', '1538533097255337986', '1538533094189318149', '1536814974324068352', '1536814955130937344', '1534576979520983041', '1533814789746597888', '1487702884045230080', '1624692957830955009', '1621536587497578498', '1620477180454248448', '1616761689377996801', '1614344641876267011', '1614194880367968257', '1612048215909728257', '1609631185034186752', '1609479683334197249', '1061552308075577345', '1048901733521547266', '1043856108388061191', '1041268238833856513', '1173161097341407232'], 'in_degree': 0, 'out_degree': 24, 'in_degree_pa': 0, 'out_degree_pa': 24}, {'id': 1, 'twitter_id': '1582853809.0', 'screen_name': 'HistoryInPics', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 2, 'twitter_id': '43598989.0', 'screen_name': 'gvissac', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 3, 'out_degree': 0, 'in_degree_pa': 3, 'out_degree_pa': 0}, {'id': 3, 'twitter_id': '327242014.0', 'screen_name': 'publienet', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 2, 'out_degree': 0, 'in_degree_pa': 2, 'out_degree_pa': 0}, {'id': 4, 'twitter_id': '8.159125882026762e+17', 'screen_name': 'Theatre_Martyrs', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 5, 'twitter_id': '20683840.0', 'screen_name': 'PJHarveyUK', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 6, 'twitter_id': '339550843.0', 'screen_name': 'LucienSuel', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 7, 'twitter_id': '262860125.0', 'screen_name': 'MarilynMonroe', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 8, 'twitter_id': '1.0629940750649548e+18', 'screen_name': 'Anthonysarti201', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 9, 'twitter_id': '14897510.0', 'screen_name': 'fabula', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 10, 'twitter_id': '1946684100.0', 'screen_name': 'antonincrenn', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 11, 'twitter_id': '50624195.0', 'screen_name': 'joachimsene', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 12, 'twitter_id': '33438650.0', 'screen_name': 'madmanclaro', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 2, 'out_degree': 0, 'in_degree_pa': 2, 'out_degree_pa': 0}, {'id': 13, 'twitter_id': '19911310.0', 'screen_name': 'cinemathequefr', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 14, 'twitter_id': '4895416258.0', 'screen_name': 'SansOserFC', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 15, 'twitter_id': '7.156213842070897e+17', 'screen_name': 'BiblioVillon', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 16, 'twitter_id': '9.347946096995574e+17', 'screen_name': 'Proprose_mag', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 17, 'twitter_id': '482170601.0', 'screen_name': 'MechBird', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 18, 'twitter_id': '16110896.0', 'screen_name': 'liminaire', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 19, 'twitter_id': '82290916.0', 'screen_name': 'livreshebdo', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}, {'id': 20, 'twitter_id': '18504485.0', 'screen_name': 'athanorster', 'followers': 0, 'friends': 0, 'interactions': 'None', 'otweets': 'None', 'in_degree': 1, 'out_degree': 0, 'in_degree_pa': 1, 'out_degree_pa': 0}], 'links': [{'source': 0, 'target': 1, 'tweet': '813815672899858434', 'ts': 1482863751}, {'source': 0, 'target': 2, 'tweet': '1184434975011151872', 'ts': 1571226278}, {'source': 0, 'target': 3, 'tweet': '1168784582235365376', 'ts': 1567494934}, {'source': 0, 'target': 4, 'tweet': '1186184877688918017', 'ts': 1571643487}, {'source': 0, 'target': 5, 'tweet': '1297185282274594816', 'ts': 1598108046}, {'source': 0, 'target': 6, 'tweet': '1252506577090809862', 'ts': 1587455813}, {'source': 0, 'target': 7, 'tweet': '1472253420232978441', 'ts': 1639847543}, {'source': 0, 'target': 8, 'tweet': '1369769003137241092', 'ts': 1615413354}, {'source': 0, 'target': 9, 'tweet': '1460720907509538816', 'ts': 1637097977}, {'source': 0, 'target': 10, 'tweet': '1426807827155324928', 'ts': 1629012469}, {'source': 0, 'target': 3, 'tweet': '1386353447134535682', 'ts': 1619367393}, {'source': 0, 'target': 11, 'tweet': '1543240645577510912', 'ts': 1656772216}, {'source': 0, 'target': 2, 'tweet': '1542190342115557378', 'ts': 1656521804}, {'source': 0, 'target': 12, 'tweet': '1519014048679043072', 'ts': 1650996145}, {'source': 0, 'target': 13, 'tweet': '1502618561625436160', 'ts': 1647087157}, {'source': 0, 'target': 14, 'tweet': '1564284349343752195', 'ts': 1661789426}, {'source': 0, 'target': 2, 'tweet': '1587359369339015168', 'ts': 1667290940}, {'source': 0, 'target': 12, 'tweet': '1585543729984700418', 'ts': 1666858057}, {'source': 0, 'target': 15, 'tweet': '1583409071801016320', 'ts': 1666349115}, {'source': 0, 'target': 16, 'tweet': '1573968700637646848', 'ts': 1664098355}, {'source': 0, 'target': 17, 'tweet': '1564274977708318722', 'ts': 1661787192}, {'source': 0, 'target': 18, 'tweet': '1563100691371294720', 'ts': 1661507220}, {'source': 0, 'target': 19, 'tweet': '1539126956079333376', 'ts': 1655791436}, {'source': 0, 'target': 20, 'tweet': '1621478845869166592', 'ts': 1675425657}], 'graph': {'type': 'Quote network', 'N_nodes': 21, 'N_links': 24, 'keyword': '', 'collected_on': 'all.twitwi', 'first_tweet': '2023-02-03 13:00', 'last_tweet': '2016-12-27 19:35'}, 'version_number': '0.6.7'}
    </script>
    
<script>

// initialize variables
var colorselector = document.getElementById("nodecolor");
var nodescaling = 0.05;
var nodecolor = colorselector.options[colorselector.selectedIndex].value;
var darkmode = false

// get node color options
ms = document.getElementById('nodecolor')
if ('louvain_com' in data.nodes[0]){ms.innerHTML+=`<option value = "louvain_com">Louvain community</option>\n`}
if ('leiden_com' in data.nodes[0]){ms.innerHTML+=`<option value = "leiden_com">Leiden community</option>\n`}

// hide links by default if there are more than 10.000
if (data.links.length > 10000) {var init_linkvis = false}
else {var init_linkvis = true}

// initialize graph
const elem = document.getElementById('graph');
const Graph = ForceGraph()(elem)
.graphData({nodes: data.nodes, links: data.links})
.nodeId('id')
.nodeLabel(node => node.screen_name)
.nodeColor(node => "black")
.nodeVal(node => node.in_degree * nodescaling)
.linkDirectionalParticleColor(() => 'red')
.linkHoverPrecision(10)
.linkVisibility(init_linkvis)
.onNodeRightClick(node => { Graph.centerAt(node.x, node.y, 1000);Graph.zoom(8, 2000);})
Graph.onLinkClick(Graph.emitParticle); // emit particles on link click

// get list of all users for autocomplete
var users = []
for(var i in data.nodes)
{users.push(data.nodes[i].screen_name)};

// draw tweets
function drawortweets (){
    if (darkmode === false) {var themecol = 'light'}
    else {var themecol = 'dark'} 
    var name = document.getElementById("searchuser").value
    document.getElementById("useroriginaltweets").innerHTML = "";
    const getNode = id => {
    return data.nodes.find(node => node.screen_name === name);
    };
    var node = getNode(name)
    highlight(node)
    if (node.otweets != "None"){
    for (tweet of node.otweets) {        
        twttr.widgets.createTweet(
          tweet,
          document.getElementById('useroriginaltweets'),
          {
            theme: themecol,
            dnt: true,
            width: 280
          }
        );  }}
    else {document.getElementById('useroriginaltweets').innerHTML = "None"}
    
$("#content04").slideUp(300)
$("#content05").slideUp(300)
$("#content04A").slideDown(300);  
}

function drawretweets (){
    if (darkmode === false) {var themecol = 'light'}
    else {var themecol = 'dark'} 
    var name = document.getElementById("searchuser").value
    document.getElementById("userretweets").innerHTML = "";
    const getNode = id => {
    return data.nodes.find(node => node.screen_name === name);
    };
    var node = getNode(name)
    highlight(node)
    if (node.interactions != "None"){
    for (tweet of node.interactions) {
        if (tweet != "None") {
        twttr.widgets.createTweet(
          tweet,
          document.getElementById('userretweets'),
          {
            theme: themecol,
            dnt: true,
            width: 280
          }
        ); }       
    }}
    else {document.getElementById('userretweets').innerHTML = "None"}

$("#content04A").slideUp(300);
$("#content05").slideUp(300);
$("#content04").slideDown(300);
}


// DRAW TWITTER TIMELINE
function drawtimeline(){
if (darkmode === false) {var themecol = 'light'}
else {var themecol = 'dark'}        
var name = document.getElementById("searchuser").value
document.getElementById("twitter_timeline").innerHTML = "";
twttr.widgets.createTimeline(
{
sourceType: "profile",
screenName: name
},
document.getElementById("twitter_timeline"),
{
theme: themecol,
height: 400,
chrome: 'noscrollbar',
dnt: true                    
});
{
$("#content05").slideDown(300);
$("#content04").slideUp(300)
$("#content04A").slideUp(300)
};                  
}

// USER INFO ON CLICK
Graph.onNodeClick((node =>  {
pastenodeinfo(node);
$("#content03").slideDown(300)
$("#content01").slideUp(300)
highlight(node)
}))

function highlight(node){
var neighbors = []
neighbors.push(node)

for (link of data.links) {
  if (link.source == node) {
    neighbors.push(link.target)
    link.colorthat = 1
  }
  else if (link.target == node){
    neighbors.push(link.source)
    link.colorthat = 1
  }
  else {link.colorthat=0}
}
for (node of data.nodes){
  if(neighbors.includes(node)){
    node.colorthat = 1
  }
  else node.colorthat = 0}
colorbar = ['#d3d3d3', 'red']
Graph.nodeColor(() => 'black') 
Graph.nodeColor(node => colorbar[node.colorthat])
// linkcolor depending on dark/lightmode
if (darkmode === false) {var colorbar2 = ['rgba(0,0,0,0.05)', 'rgba(255,0,0,0.5)']}
else {var colorbar2 = ['rgba(255,255,255,0.03)', 'rgba(255,0,0,0.5)']}
Graph.linkColor(link => colorbar2[link.colorthat])
}
Graph.linkDirectionalParticles(link => {
  if (link.colorthat == 1) {
    return 1}
    else {
      return 0
    }})

Graph.onBackgroundClick(() => resetcolors())

function resetcolors(){
var bodyelement = document.querySelector('body')
var bodystyle = window.getComputedStyle(bodyelement)
var bg = bodystyle.getPropertyValue('color')
if (bg === 'rgb(0, 0, 0)') {
  var linkcol = 'rgba(0,0,0,0.2)'}
if (bg === 'rgb(255, 255, 255)') {
  var linkcol = 'rgba(255,255,255,0.2)'}

recolornodes()
Graph.linkColor(() => linkcol)}


var input = document.getElementById("searchuser");
new Awesomplete(input, {
list: users
});

// ZOOM ON USER
function zoomonuser(){
var name = document.getElementById("searchuser").value;
const getNode = id => {
return data.nodes.find(node => node.screen_name === name);
}
var nodeathand = getNode(name)
Graph.centerAt(nodeathand.x, nodeathand.y, 1000);Graph.zoom(8, 2000);
console.log(nodeathand);}

// FLASH COLOR
function flashcolor(){
var bodyelement = document.querySelector('body')
var bodystyle = window.getComputedStyle(bodyelement)
var bg = bodystyle.getPropertyValue('color')
if (bg === 'rgb(0, 0, 0)') {var nodecol = 'black'}
if (bg === 'rgb(255, 255, 255)') {var nodecol = 'white'}
var name = document.getElementById("searchuser").value;
const getNode = id => {
return data.nodes.find(node => node.screen_name === name);
};
var nodeathand = getNode(name)
console.log(nodeathand)
originalcolor = nodeathand.color
Graph.nodeColor(node => {
if (node.screen_name === name) {
return "red";
}
else {return nodecol}
});
setTimeout(function(){            
Graph.nodeColor(node => {
if (node.screen_name === name) {
return nodecol;
}
else {return nodecol}
});
}, 250);}

function resetzoom(){
Graph.centerAt(0, 0,1000);Graph.zoom(0.4, 1000)
}

// LIGHT / DARK MODE
function toggle_darkmode(){
    
    if (darkmode == false) 
    {
        document.documentElement.setAttribute('data-theme', 'darktheme');
        Graph.linkColor(() => 'rgba(255,255,255,0.2)');
        var colorselector = document.getElementById("nodecolor");
        var selectedoption = colorselector.options[colorselector.selectedIndex].value               
        if (selectedoption === "none") {Graph.nodeColor(() => 'white')}
        darkmode = true 
    }
    else 
    {
        document.documentElement.setAttribute('data-theme', 'lighttheme');
        Graph.linkColor(() => 'rgba(0,0,0,0.2)');
        var colorselector = document.getElementById("nodecolor");
        var selectedoption = colorselector.options[colorselector.selectedIndex].value                               
        if (selectedoption === "none") {Graph.nodeColor(() => 'black')}
        darkmode = false 
    }
}

// RECOLOR NODES
var colorscale = ['#e6194b', '#3cb44b', '#ffe119', '#4363d8', '#f58231', '#911eb4', '#46f0f0', '#f032e6', '#bcf60c', '#fabebe', '#008080', '#e6beff', '#9a6324', '#fffac8', '#800000', '#aaffc3', '#808000', '#ffd8b1', '#000075', '#808080', '#ffffff', '#000000']
document.getElementById("nodecolor").addEventListener("change", recolornodes);

function recolornodes(){
var colorselector = document.getElementById("nodecolor");
var selectedoption = colorselector.options[colorselector.selectedIndex].value
if (selectedoption != "none"){
Graph.nodeColor(node => colorscale[node[selectedoption]])}            
else { 
var bodyelement = document.querySelector('body')
var bodystyle = window.getComputedStyle(bodyelement)
var bg = bodystyle.getPropertyValue('color')
if (bg === 'rgb(0, 0, 0)') {var nodecol = 'black'}
if (bg === 'rgb(255, 255, 255)') {var nodecol = 'white'}
Graph.nodeColor(node => nodecol)} }

// NODE SIZE
document.getElementById("slido").addEventListener("change", rescalenodes);
function rescalenodes(){
  var nodescaleslider = document.getElementById("slido");
  var newscale = nodescaleslider.value  
  var sizeselector = document.getElementById("nodesize");
  var selectedoption = sizeselector.options[sizeselector.selectedIndex].value
  if      (selectedoption === "followers"){Graph.nodeVal(node => node[selectedoption] * 0.000005 * newscale)}            
  else if (selectedoption === "friends"){Graph.nodeVal(node => node[selectedoption] * 0.001 * newscale)}
  else if (selectedoption === "out_degree"){Graph.nodeVal(node => node[selectedoption] * 0.1 * newscale)}
  else if (selectedoption === "in_degree"){Graph.nodeVal(node => node[selectedoption] * 0.1 * newscale)}              
}

document.getElementById("nodesize").addEventListener("change", changenodesize);
function changenodesize(){
var sizeselector = document.getElementById("nodesize");
var selectedoption = sizeselector.options[sizeselector.selectedIndex].value
if      (selectedoption === "followers"){Graph.nodeVal(node => node[selectedoption] * 0.00005)}            
else if (selectedoption === "friends"){Graph.nodeVal(node => node[selectedoption] * 0.001)}
else if (selectedoption === "out_degree"){Graph.nodeVal(node => node[selectedoption] * 1.0)}
else if (selectedoption === "in_degree"){Graph.nodeVal(node => node[selectedoption] * 1.0)}              
else { Graph.nodeVal(node => 1.0)} 
}

$(function() {
var colval="none"; 
$("#nodecolor").val(colval);
});
$(function() {
var sizeval="in_degree"; 
$("#nodesize").val(sizeval);
});


// INCLUDE NETWORK INFORMATION FROM GRAPH DATA
var netinfo = `<ul> 
<li> Keyword: ${data.graph.keyword}</li>
<li> Collected on: ${data.graph.collected_on}</li>
<li> First retweet: ${data.graph.first_tweet}</li>
<li> Last retweet: ${data.graph.last_tweet}</li>
</ul>`
var netmeasures = `
<ul>
  <li>Nodes: ${data.graph.N_nodes}</li>
  <li>Links: ${data.graph.N_links}</li>
</ul>`
document.getElementById('panel00').innerHTML = data.graph.type
document.getElementById('content00').innerHTML = netinfo
document.getElementById('content02').innerHTML = netmeasures
document.getElementById('version_number').innerHTML = data.version_number

// NODE INFO
function pastenodeinfo(node){
userinfostring = `<ul> 
<li> Followers: ${node.followers}
<li> Followed accounts: ${node.friends}
<li> Times the user ${interaction_type_past.split(' ')[0]}: ${node.out_degree}
<li> Times the user got ${interaction_type_past}: ${node.in_degree}`
if ("louvain_com" in node){
    userinfostring += `<li> Louvain community: ${node.louvain_com}`
}
if ("leiden_com" in node){
    userinfostring += `<li> Leiden community: ${node.leiden_com}`
}
userinfostring += `</ul>`
document.getElementById('userinfostring').innerHTML = userinfostring
document.getElementById("searchuser").value = node.screen_name
}


var interaction_type = data.graph.type.split(' ')[0].toLowerCase()

if (interaction_type == "retweet"){
    document.getElementById('indegreeoption').innerHTML = "In-Degree (Number of times the account got retweeted)"
    document.getElementById('outdegreeoption').innerHTML = "Out-Degree (Number of times the account retweeted another)"    
    document.getElementById('panel04').innerHTML = "RETWEETS IN DATASET"
    document.getElementById('fetch_interaction').innerHTML = "Fetch retweets"
    var interaction_type_past = "retweeted"
}

if (interaction_type == "quote"){
    document.getElementById('indegreeoption').innerHTML = "In-Degree (Number of times the account got quoted)"
    document.getElementById('outdegreeoption').innerHTML = "Out-Degree (Number of times the account quoted another)"    
    document.getElementById('panel04').innerHTML = "QUOTES IN DATASET"
    document.getElementById('fetch_interaction').innerHTML = "Fetch quotes"
    var interaction_type_past = "quoted"
}
if (interaction_type == "reply"){
    document.getElementById('indegreeoption').innerHTML = "In-Degree (Number of times the account got replied to)"
    document.getElementById('outdegreeoption').innerHTML = "Out-Degree (Number of times the account replied to another)"    
    document.getElementById('panel04').innerHTML = "REPLIES IN DATASET"
    document.getElementById('fetch_interaction').innerHTML = "Fetch replies"
    var interaction_type_past = "replied to"
}
if (interaction_type == "mention"){
    document.getElementById('indegreeoption').innerHTML = "In-Degree (Number of times the account got mentioned)"
    document.getElementById('outdegreeoption').innerHTML = "Out-Degree (Number of times the account mentioned another)"    
    document.getElementById('panel04').innerHTML = "MENTIONS IN DATASET"
    document.getElementById('fetch_interaction').innerHTML = "Fetch mentions"
    var interaction_type_past = "mentioned"
    document.getElementById('fetch_originaltweet').style="display:none"
    document.getElementById('originaltweetsborders').style="display:none"    
}

$("#content00").slideToggle(300)

function toggle_linkvisibility(){
    if (Graph.linkVisibility() == true){
        Graph.linkVisibility(false)
    }
    else {Graph.linkVisibility(true)}
}

function make_screenshot(){
// var canvas = document.getElementsByClassName('force-graph-container')[0]['children'][0];
var canvas = document.getElementById('graph')['children'][0]['children'][0]
console.log(canvas)
var link = document.getElementById('camera');
link.setAttribute('download', 'screenshot.png');
link.setAttribute('href', canvas.toDataURL("image/png").replace("image/png", "image/octet-stream"));
link.click()
}

function export_nodes_as_csv(){
    var csv_string = ""
    var options = Object.keys(data.nodes[0])
    var to_disregard = ['otweets','interactions','vx','vy','index']
    var filtered_options = options.filter(function(e) { return !to_disregard.includes(e)})
    for (option of filtered_options)
        {csv_string += option;csv_string += ","}
    csv_string = csv_string.slice(0, -1)
    csv_string += "\n"
    for (var i = 0; i < data.nodes.length; ++i)
    // for (var i = 0; i < 2; ++i)
        {
            node = data.nodes[i]
            for (option of filtered_options){
                csv_string += node[option]
                csv_string += ","
            }
            csv_string = csv_string.slice(0, -1)
            csv_string += "\n"
        }
    csv_string = csv_string.slice(0, -1)
    var blob = new Blob([csv_string],
      { type: "text/plain;charset=utf-8" });
    saveAs(blob, "nodes_metadata.csv");
}

function d3graph_to_gml(){
  var gml_string = "graph\n[\n"
  var options = Object.keys(data.nodes[0])
  var to_disregard = ['otweets','interactions','vx','vy','index']
  var filtered_options = options.filter(function(e) { return !to_disregard.includes(e)})
  for (var i = 0; i < data.nodes.length; ++i){
    node = data.nodes[i]
    gml_string += "node\n"
    gml_string += "[\n"
    for (option of filtered_options){
      if (node[option].constructor !== Array || typeof node[option] !== 'object') {
      if (typeof node[option] === 'string' || node[option] instanceof String){
        gml_string += option + " " + '"' + node[option] + '"' + "\n"
      }
      else {
      gml_string += option + " " + node[option] + "\n"
    }}}
    gml_string += "]\n"
  }
  for (var i = 0; i < data.links.length; ++i){
    link = data.links[i], source = link.source, target = link.target;
    gml_string += "edge\n"
    gml_string += "[\n" 
    gml_string += "source " + source.id + "\n"
    gml_string += "target " + target.id + "\n"
    gml_string += "]\n"
  }
  gml_string += "]"
  var blob = new Blob([gml_string],
      { type: "text/plain;charset=utf-8" });
  saveAs(blob, "network.gml");
}
    function monthDiff(d1, d2) {
        var months;
        months = (d2.getFullYear() - d1.getFullYear()) * 12;
        months -= d1.getMonth();
        months += d2.getMonth();
        return months <= 0 ? 0 : months;
    }        
    function dayDiff(d1, d2) {
        const oneDay = 24 * 60 * 60 * 1000;
        var days;
        var diffDays = Math.round(Math.abs((d1 - d2) / oneDay));
        return diffDays
    }        

    function padStr(i) {
        return (i < 10) ? "0" + i : "" + i;
    }
    function addMonths(date, months) {
        var d = date.getDate();
        date.setMonth(date.getMonth() + +months);
        if (date.getDate() != d) {
          date.setDate(0);
        }
        return date;
    }
    function addDays(date, days) {
        var d = date.getDate();
        date.setDate(date.getDate() + +days);
        // if (date.getDate() != d) {
        //   date.setDate(0);
        // }
        return date;
    }

    // FILTER EDGES BY DATE SECTION
    var all_dates = []
    for (link of data.links){all_dates.push(new Date(link.ts * 1000))}
    all_dates.sort((date1, date2) => date1 - date2)

    // get the number of elements in the slider
    var n_days = dayDiff(all_dates[0],all_dates[all_dates.length-1]) + 1

    var first_year = all_dates[0].getFullYear()
    var first_month = all_dates[0].getMonth()+1
    var first_day = all_dates[0].getDay()+1
    var idx_to_date = {} 
    var idx_to_timestamp = {} 

    for (let i = 0; i < n_days; i++){
        var newdate = new Date(all_dates[0].getTime());        
        newdate = addDays(newdate,i)
        // console.log(i)
        // idx_to_date[i] = `${first_year}-${first_month}+${i}`
        newdate.setHours(0,0,0,0);
        idx_to_date[i] = padStr(newdate.getFullYear())+"-"+padStr(1 + newdate.getMonth())+"-"+padStr(newdate.getDate())
        idx_to_timestamp[i] = newdate.getTime() / 1000
        }
// console.log(all_dates)
// console.log(idx_to_date)

document.getElementById("time_slider").max = n_days-1;
document.getElementById("time_slider").addEventListener("change", filter_edges_by_time);

function filter_edges_by_time(){        
    var timeslider = document.getElementById("time_slider").value;
    // console.log(idx_to_date[timeslider])
    var show_this_date = idx_to_date[timeslider]
    var compute_this_date = idx_to_timestamp[timeslider]
    // console.log(new Date(compute_this_date * 1000))
    document.getElementById("current_time_filter").innerHTML = show_this_date        

    // USE THIS IF YOU ONLY WANT TO ALTER THE LINKS
    // for (link of data.links){    
    //     if (link.ts > compute_this_date && link.ts < compute_this_date+(60*60*24)) {link.show=true;temporal_nodes.push(link.source);temporal_nodes.push(link.target) }
    //     else {link.show=false}}

    for (link of data.links){
        link.source.show=false
        link.target.show=false
    }
    for (link of data.links){
        if (link.ts >= compute_this_date && link.ts <= compute_this_date+(60*60*24)) 
            {link.show=true;
             link.source.show=true;
             link.target.show=true;}
        else {link.show=false}}


    Graph.linkVisibility(link => link.show)

    var colorselector = document.getElementById("nodecolor");
    var selectedoption = colorselector.options[colorselector.selectedIndex].value
    if (selectedoption != "none"){
    Graph.nodeColor(node => {if (node.show == true) {return colorscale[node[selectedoption]]} 
                             else {return 'rgba(0,0,0,0.07)'}   })
                                 }            
    else { 
    var bodyelement = document.querySelector('body')
    var bodystyle = window.getComputedStyle(bodyelement)
    var bg = bodystyle.getPropertyValue('color')
    if (bg === 'rgb(0, 0, 0)') {var nodecol = 'black'}
    if (bg === 'rgb(255, 255, 255)') {var nodecol = 'white'}
    Graph.nodeColor(node => {if (node.show == true) {return nodecol} 
                             else {return 'rgba(0,0,0,0.07)'}   })}
    // Graph.nodeVisibility(node => node.show)
    }
</script>
</body>